## kickpass 0.2.0

=== CMakeLists.txt ===
#
# Copyright (c) 2015 Paul Fariello <paul@fariello.eu>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

# Configure cmake
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/build)
set(CTEST_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/build)

# Configure project
project(KickPass C)

include(CheckLibraryExists)

include(GetGitRevisionDescription)
git_describe(KickPass_VERSION "--always")
if (NOT KickPass_VERSION OR "$ENV{TRAVIS}")
	set(KickPass_VERSION_MAJOR 0)
	set(KickPass_VERSION_MINOR 2)
	set(KickPass_VERSION_PATCH 0)
else()
	message(STATUS "Kickpass git version: ${KickPass_VERSION}")
	string(REGEX REPLACE "v([0-9]+).*" "\\1"
		KickPass_VERSION_MAJOR ${KickPass_VERSION})
	string(REGEX REPLACE "v[0-9]+\\.([0-9]+).*" "\\1"
		KickPass_VERSION_MINOR ${KickPass_VERSION})
	string(REGEX REPLACE "v[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1"
		KickPass_VERSION_PATCH ${KickPass_VERSION})
endif()
message(STATUS "Kickpass version: ${KickPass_VERSION_MAJOR}.${KickPass_VERSION_MINOR}.${KickPass_VERSION_PATCH}")

include_directories("${PROJECT_BINARY_DIR}/include/")
include_directories("${PROJECT_SOURCE_DIR}/include/")
include_directories("${PROJECT_SOURCE_DIR}/src/")

set(SRCS
	src/editor.c
	src/main.c
	src/prompt.c
	src/log.c
	# commands
	src/command/create.c
	src/command/delete.c
	src/command/edit.c
	src/command/init.c
	src/command/list.c
	src/command/cat.c
	src/command/rename.c
	src/command/agent.c
	src/command/open.c
)

# Configure dependencies
find_package(Sodium 1.0.0 REQUIRED)
message(STATUS "Libsodium version: ${SODIUM_VERSION}")
include_directories(${SODIUM_INCLUDE_DIRS})
set(LIBS ${LIBS} ${SODIUM_LIBRARIES})

check_library_exists(c readpassphrase "readpassphrase.h" HAVE_READPASSPHRASE)
if (NOT HAVE_READPASSPHRASE)
	find_package(BSD REQUIRED)
	include_directories(${BSD_INCLUDE_DIRS}/bsd)
	set(LIBS ${LIBS} ${BSD_LIBRARIES})
	# Add _GNU_SOURCE for asprintf
	add_definitions(-DLIBBSD_OVERLAY -D_GNU_SOURCE)
endif()

check_library_exists(util imsg_init "imsg.h" HAVE_IMSG)
if (HAVE_IMSG)
	set(LIBS ${LIBS} util)
else()
	add_library(imsg STATIC
		${CMAKE_SOURCE_DIR}/compat/bsd/imsg-buffer.c
		${CMAKE_SOURCE_DIR}/compat/bsd/imsg.c
		${CMAKE_SOURCE_DIR}/compat/bsd/imsg.h
	)

	include_directories(${CMAKE_SOURCE_DIR}/compat/bsd/)
	set(LIBS ${LIBS} imsg)
endif()

find_package(Event2 REQUIRED)
include_directories(${EVENT2_INCLUDE_DIRS})
set(LIBS ${LIBS} ${EVENT2_LIBRARIES})

find_package(X11)
if (X11_FOUND)
	include_directories(${X11_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${X11_LIBRARIES})
	set(SRCS ${SRCS} src/command/copy.c)
	set(HAS_X11 true)
else()
	message(WARNING "X11 not found. Skipping copy command.")
endif()

# Sources
configure_file(
	"${PROJECT_SOURCE_DIR}/include/kickpass_config.h.in"
	"${PROJECT_BINARY_DIR}/include/kickpass_config.h"
)

add_executable(kickpass ${SRCS})

# Link all dependencies
target_link_libraries(kickpass ${LIBS})

# kickpass lib
add_library(libkickpass SHARED
	lib/config.c
	lib/error.c
	lib/kickpass.c
	lib/password.c
	lib/safe.c
	lib/storage.c
	lib/kpagent.c
)

set_target_properties(libkickpass PROPERTIES
	VERSION ${KickPass_VERSION_MAJOR}.${KickPass_VERSION_MINOR}.${KickPass_VERSION_PATCH}
	SOVERSION ${KickPass_VERSION_MAJOR})
set_target_properties(libkickpass PROPERTIES OUTPUT_NAME kickpass)

target_link_libraries(kickpass libkickpass)

# Configure build
set(BUILD "Release" CACHE STRING "Selected build type")
if(NOT ("$ENV{BUILD}" STREQUAL ""))
	set(CMAKE_BUILD_TYPE $ENV{BUILD})
else()
	set(CMAKE_BUILD_TYPE ${BUILD})
endif()

message(STATUS "Build configuration (BUILD): ${CMAKE_BUILD_TYPE}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_DEFAULT_SOURCE -D_BSD_SOURCE")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -D_FORTIFY_SOURCE=2 -fstack-protector")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wall -Werror")

# Configure install

install(TARGETS kickpass libkickpass RUNTIME DESTINATION bin LIBRARY DESTINATION lib)
install(FILES manual/kickpass.1 DESTINATION share/man/man1/)
install(FILES extra/completion/zsh/_kickpass DESTINATION share/zsh/site-functions/)

# Tests
enable_testing()
add_subdirectory(test)

# Packaging
include(Package)

=== test/CMakeLists.txt ===
#
# Copyright (c) 2015 Paul Fariello <paul@fariello.eu>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

include(Test)
include(CheckLibraryExists)

find_library(M_LIB m)
set(TEST_LIBS ${LIBS} ${M_LIB})
check_library_exists(c timer_create "" HAVE_TIMER_CREATE)
if (NOT HAVE_TIMER_CREATE)
	check_library_exists(rt timer_create "time.h" HAVE_TIMER_CREATE_IN_RT)
	if (HAVE_TIMER_CREATE_IN_RT)
		find_library(RT_LIB rt)
		set(TEST_LIBS ${TEST_LIBS} ${RT_LIB})
	else()
		message(FATAL_ERROR "can't find timer_create function")
	endif()
endif()
find_library(PTHREAD_LIB pthread)
set(TEST_LIBS ${TEST_LIBS} ${PTHREAD_LIB})

UNIT_TEST(NAME storage FILE storage.c LIBS libkickpass ${TEST_LIBS})
UNIT_TEST(NAME safe FILE safe.c LIBS libkickpass ${TEST_LIBS})
INTEGRATION_TEST(NAME init FILE init.py)
INTEGRATION_TEST(NAME create FILE create.py)
INTEGRATION_TEST(NAME edit FILE edit.py)
INTEGRATION_TEST(NAME list FILE list.py)
INTEGRATION_TEST(NAME cat FILE cat.py)
INTEGRATION_TEST(NAME open FILE open.py)
INTEGRATION_TEST(NAME delete FILE delete.py)
INTEGRATION_TEST(NAME rename FILE rename.py)

=== debian/changelog ===
kickpass (0.2.0-6ubuntu2) noble; urgency=medium

  * No-change rebuild for libevent t64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Apr 2024 10:15:11 +0200

kickpass (0.2.0-6ubuntu1) mantic; urgency=medium

  * Drop patch 20_add_flags which injects pie flags manually
    pie is enabled by default by gcc. (LP: #2021577)

 -- Shengjing Zhu <shengjing.zhu@canonical.com>  Tue, 30 May 2023 16:50:38 +0800

kickpass (0.2.0-6) unstable; urgency=medium

  * debian/control: bumped Standards-Version to 4.6.2.
  * debian/gbp.conf: file created.
  * debian/patches/20_add_flags: created.

 -- Paulo Henrique de Lima Santana (phls) <phls@debian.org>  Wed, 18 Jan 2023 20:50:56 -0300

kickpass (0.2.0-5) unstable; urgency=medium

  * debian/control: bumped Standards-Version to 4.6.1.
  * debian/copyright: updated packaging copyright years.
  * debian/upstream/metadata:
      - Fixed upstream metadata fields: Repository.
      - Removed obsolete field Name from debian/upstream/metadata (already
        present in machine-readable debian/copyright).
  * debian/watch: updated.

 -- Paulo Henrique de Lima Santana (phls) <phls@debian.org>  Thu, 05 Jan 2023 16:56:02 -0300

kickpass (0.2.0-4) unstable; urgency=medium

  * debian/control:
      - Added Multi-Arch option with foreign.
      - Bumped Standards-Version to 4.5.1.
      - Updated DH to level 13.
  * debian/copyright: updated packaging copyright years.
  * debian/sources/include-binaries: created to add a file to improve
    autopkgtest.
  * debian/tests/control: improve test. (Closes: #969836)

 -- Paulo Henrique de Lima Santana (phls) <phls@debian.org>  Tue, 22 Dec 2020 13:20:09 -0300

kickpass (0.2.0-3) unstable; urgency=medium

  * debian/salsa-ci.yml: allow reprotest failure.

 -- Paulo Henrique de Lima Santana (phls) <phls@debian.org>  Tue, 24 Dec 2019 02:10:21 +0300

kickpass (0.2.0-2) unstable; urgency=medium

  * debian/control:
      - Added 'Rules-Requires-Root: no' in source stanza.
      - Change Maintainer's email.
      - Change Vcs-* fields for new repository in salsa.
      - Bumped Standards-Version to 4.4.1.
      - Updated DH to level 12.
  * debian/copyright:
      - Change Maintainer's email.
      - Updated packaging copyright years.
  * debian/salsa-ci.yml: created to start CI tests for Salsa.

 -- Paulo Henrique de Lima Santana (phls) <phls@debian.org>  Mon, 23 Dec 2019 05:22:16 +0300

kickpass (0.2.0-1) unstable; urgency=medium

  * Initial release to Debian (Closes: #913435).

  * Upload sponsored by Mike Gabriel (aka sunweaver).

 -- Paulo Henrique de Lima Santana (phls) <phls@softwarelivre.org>  Wed, 14 Nov 2018 17:21:41 -0200

=== debian/control ===
Source: kickpass
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paulo Henrique de Lima Santana (phls) <phls@debian.org>
Build-Depends: check,
               cmake,
               debhelper-compat (= 13),
               libbsd-dev,
               libevent-dev,
               libsodium-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/kickpass/kickpass
Vcs-Browser: https://salsa.debian.org/debian/kickpass
Vcs-Git: https://salsa.debian.org/debian/kickpass.git

Package: kickpass
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: simple password safe
 It keep each password  in a specific safe, protected with modern cryptography.
 Command line interface is splited into different command.
 .
 It has features like:
   * One password to rule them all;
   * Oone password to find them;
   * One password to bring them all
   * Integrated password generator;
   * Full text  metadata with your favorite editor;
   * Direct copy to X selection and clipboard;
   * Strong encryption: AEAD with chacha20 and poly1305.

Package: libkickpass0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: library used by kickpass
 Kickpass is built around this shared library. libkickpass leverage libsodium
 to create safes. Safes are created using authenticated encryption with
 associated data. As of now libkickpass use chacha20 along with poly1305 to
 encrypt and authenticate the safe.

Package: libkickpass-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libkickpass0 (= ${binary:Version}),
Description: library used by kickpass (development files)
 Kickpass is built around this shared library. libkickpass leverage libsodium
 to create safes. Safes are created using authenticated encryption with
 associated data. As of now libkickpass use chacha20 along with poly1305 to
 encrypt and authenticate the safe.
 .
 This package provides the development files.

=== debian/tests/control ===
Test-Command: HOME=debian/tests; kickpass list

=== debian/watch ===
version=4
https://github.com/kickpass/kickpass/tags .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
